package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/DynamicsSimulatorPOA.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/DynamicsSimulator.idl
* 2009年2月18日 12時58分36秒 JST
*/


/**
	 * @if jp
	 * @brief DynamicsSimulator インターフェース
	 *
	 * 力学シミュレーションを行うサーバです。使用する際は以下の流れで行います。
	 *
	 * -# DynamicsSimulatorFactory の参照を取得
	 * -# DynamicsSimulatorFactory::create() で DynamicsSimulator を取得
	 * -# registerCharacter() でキャラクタを登録
	 * -# init() でシミュレーションの設定
	 * -# setGVector() で重力ベクトルの設定
	 * -# setCharacterAllJointModes() で関節駆動モードの設定
	 * -# setCharacterAllLinkData() で初期姿勢を与え、 calcWorldForwardKinematics() を実行し順運動学を１回実行
	 * -# registerCollisionCheckPair() をどの関節/キャラクタに対して干渉チェックを実行するかを設定する
	 * -# initSimulation() でサーバの初期化
	 *
	 * 以下、シミュレーションループ
	 *
	 * -# stepSimulation() でシミュレーションを1ステップ実行
	 * -# getWorldState() で現在の状況を取得
	 * @else
	 * Dynamics Server
	 *
	 * @date	2006.02.02
	 * @version	pre2.0 
	 * modified	2006.02.24 some functions needed to specify character name
	 * @endif
	 */
public abstract class DynamicsSimulatorPOA extends org.omg.PortableServer.Servant
 implements jp.go.aist.hrp.simulator.DynamicsSimulatorOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("destroy", new java.lang.Integer (0));
    _methods.put ("registerCharacter", new java.lang.Integer (1));
    _methods.put ("init", new java.lang.Integer (2));
    _methods.put ("registerCollisionCheckPair", new java.lang.Integer (3));
    _methods.put ("registerVirtualLink", new java.lang.Integer (4));
    _methods.put ("getConnectionConstraintForce", new java.lang.Integer (5));
    _methods.put ("getCharacterSensorValues", new java.lang.Integer (6));
    _methods.put ("initSimulation", new java.lang.Integer (7));
    _methods.put ("stepSimulation", new java.lang.Integer (8));
    _methods.put ("setCharacterLinkData", new java.lang.Integer (9));
    _methods.put ("getCharacterLinkData", new java.lang.Integer (10));
    _methods.put ("getCharacterAllLinkData", new java.lang.Integer (11));
    _methods.put ("setCharacterAllLinkData", new java.lang.Integer (12));
    _methods.put ("setGVector", new java.lang.Integer (13));
    _methods.put ("getGVector", new java.lang.Integer (14));
    _methods.put ("setCharacterAllJointModes", new java.lang.Integer (15));
    _methods.put ("calcCharacterInverseKinematics", new java.lang.Integer (16));
    _methods.put ("calcCharacterForwardKinematics", new java.lang.Integer (17));
    _methods.put ("calcWorldForwardKinematics", new java.lang.Integer (18));
    _methods.put ("checkCollision", new java.lang.Integer (19));
    _methods.put ("getWorldState", new java.lang.Integer (20));
    _methods.put ("getCharacterSensorState", new java.lang.Integer (21));
    _methods.put ("getCharacterCollidingPairs", new java.lang.Integer (22));
    _methods.put ("calcCharacterJacobian", new java.lang.Integer (23));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
  		 * @if jp
  		 * サーバを終了します。
  		 * @else
  		 * Object Destruction
  		 * @endif
  		 */
       case 0:  // OpenHRP/DynamicsSimulator/destroy
       {
         this.destroy ();
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief キャラクタを登録する。
  		 * 
  		 * ModelLoader から得られた情報でキャラクタを登録します。
  		 * @param name シミュレーションでのキャラクタ名
  		 * @param cinfo ModelLoader から得られる CharacterInfo
  		 * @else
  		 * Register a character
  		 * @param	name	Object Character Name for Simulation
  		 * @param	cinfo	CharacterInfo
  		 * @endif
  		 */
       case 1:  // OpenHRP/DynamicsSimulator/registerCharacter
       {
         String name = in.read_string ();
         jp.go.aist.hrp.simulator.CharacterInfo cinfo = jp.go.aist.hrp.simulator.CharacterInfoHelper.read (in);
         this.registerCharacter (name, cinfo);
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief サーバを初期化します。
  		 *
  		 * シミュレーションの条件を設定し、サーバを初期化します。
  		 * @param timeStep シミュレーション1ステップごとの時間[s]
  		 * @param integrateopt 積分に用いる手法(オイラー法, ルンゲクッタ法)
  		 * @param sensorOpt センサーを使用するか
  		 * @else
  		 * Initialise Server
  		 * @param timeStep		The timestep to be used for integration.
  		 * @param integrateOpt  The integration method to use.
  		 * @param sensorOpt	    The sensor option to be used.
  		 * @endif
  		 */
       case 2:  // OpenHRP/DynamicsSimulator/init
       {
         double timeStep = in.read_double ();
         jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.IntegrateMethod integrateOpt = jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.IntegrateMethodHelper.read (in);
         jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.SensorOption sensorOpt = jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.SensorOptionHelper.read (in);
         this.init (timeStep, integrateOpt, sensorOpt);
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief 衝突検出ペアを追加します。
  		 *
  		 * ここで登録されたペア同士の衝突検出が行われます。
  		 *
  		 * K と C の長さを0にするとスプリング-ダンパ法は使用されません。
  		 * @param	char1	  リンクのキャラクタ名
  		 * @param	name1	  リンク名
  		 * @param	char2     もう一方のキャラクタ名
  		 * @param	name2     リンク名
  		 * @param	staticFriction  静止摩擦係数
  		 * @param   slipFriction  動摩擦係数
  		 * @param	K ばね係数
  		 * @param	C ダンパ係数
  		 * @else
  		 * Add Collision Pairs
  		 * @param	char1	  Name of character for first link
  		 * @param	name1	  Name of first link
  		 * @param	char2     Name of character for second link
  		 * @param	name2     Name of second link
  		 * @param	staticFriction  Static Friction
  		 * @param   slipFriction  Slip Friction
  		 * @param	K Parameters for Spring
  		 * @param	C Parameters for Damper
  		 * K and C should be of zero length for no Spring-Damper stuff.
  		 * @endif
  		 */
       case 3:  // OpenHRP/DynamicsSimulator/registerCollisionCheckPair
       {
         String char1 = in.read_string ();
         String name1 = in.read_string ();
         String char2 = in.read_string ();
         String name2 = in.read_string ();
         double staticFriction = in.read_double ();
         double slipFriction = in.read_double ();
         double K[] = jp.go.aist.hrp.simulator.DblSequence6Helper.read (in);
         double C[] = jp.go.aist.hrp.simulator.DblSequence6Helper.read (in);
         this.registerCollisionCheckPair (char1, name1, char2, name2, staticFriction, slipFriction, K, C);
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief 仮想リンクを追加します。
  		 *
  		 * @note 実装されていません。
  		 * @param	char1			 キャラクタ名
  		 * @param	link1			 リンク名
  		 * @param	char2			 もう一方のキャラクタ名
  		 * @param	link2			 リンク名
  		 * @param	relTransform	 ふたつのリンク関係の回転/位置のクォータニアン
  		 * @param   transformDefined どちらの変換が使用されるか
  		 * @param	constraint		 拘束する自由度
  		 * @param	connectionName	 仮想リンクの名前
  		 *
  		 * @else
  		 * register Virtual Link
  		 * @param	char1			 Name of character for first link
  		 * @param	link1			 Name of first link
  		 * @param	char2			 Name of character for second link
  		 * @param	link2			 Name of second link
  		 * @param	relTransform	 relative pos+att as quaternion transform
  		 * @param   transformDefined Flag for whether tranform is defined.
  		 * @param	constraint		 Constraints to be included in Link.
  		 * @param	connectionName	 Name for the virtual link.
  		 * Unimplemented
  		 * @endif
  		 */
       case 4:  // OpenHRP/DynamicsSimulator/registerVirtualLink
       {
         String char1 = in.read_string ();
         String link1 = in.read_string ();
         String char2 = in.read_string ();
         String link2 = in.read_string ();
         jp.go.aist.hrp.simulator.LinkPosition relTransform = jp.go.aist.hrp.simulator.LinkPositionHelper.read (in);
         short transformDefined = in.read_short ();
         double constraint[] = jp.go.aist.hrp.simulator.DblSequence9Helper.read (in);
         String connectionName = in.read_string ();
         this.registerVirtualLink (char1, link1, char2, link2, relTransform, transformDefined, constraint, connectionName);
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief registerVirtualLink() で登録した拘束にかかる力を取得します。
  		 *
  		 * @note 実装されていません
  		 * @param	characterName   キャラクタ名
  		 * @param	connectionName  コネクション名
  		 * @param	contactForce    拘束にかかる力
  		 *
  		 * @else
  		 * Get Connection Constraint Force
  		 *
  		 * @param	characterName   Character Name
  		 * @param	connectionName  Connection Name
  		 * @param	contactForce    Connection Contraint Force
  		 * unimplemented
  		 * @endif
  		 */
       case 5:  // OpenHRP/DynamicsSimulator/getConnectionConstraintForce
       {
         String characterName = in.read_string ();
         String connectionName = in.read_string ();
         jp.go.aist.hrp.simulator.DblSequence6Holder contactForce = new jp.go.aist.hrp.simulator.DblSequence6Holder ();
         this.getConnectionConstraintForce (characterName, connectionName, contactForce);
         out = $rh.createReply();
         jp.go.aist.hrp.simulator.DblSequence6Helper.write (out, contactForce.value);
         break;
       }


  /**
  		 * @if jp
  		 * @brief センサ値を取得します。
  		 *
  		 * @param   characterName	センサーがついているキャラクタ名
  		 * @param	sensorName		センサ名
  		 * @param	sensorOutput	センサ出力
  		 *
  		 * @else
  		 * Get Sensor Values
  		 * @param   characterName	Name of character with sensor.
  		 * @param	sensorName		Name of sensor.
  		 * @param	sensorOutput	Place to put data from sensor.
  		 * @endif
  		 */
       case 6:  // OpenHRP/DynamicsSimulator/getCharacterSensorValues
       {
         String characterName = in.read_string ();
         String sensorName = in.read_string ();
         jp.go.aist.hrp.simulator.DblSequenceHolder values = new jp.go.aist.hrp.simulator.DblSequenceHolder ();
         this.getCharacterSensorValues (characterName, sensorName, values);
         out = $rh.createReply();
         jp.go.aist.hrp.simulator.DblSequenceHelper.write (out, values.value);
         break;
       }


  /**
  		 * @if jp
  		 * @brief シミュレーション前の初期化をおこないます。
  		 *
  		 * このメソッドは全ての設定が終了した後に呼ばれなければなりません。
  		 * メソッド stepSimulation() はこのメソッド終了後に呼ぶことができます。
  		 * @else
  			Initialize the simulation state so that the simulator can begin a simulation.
  
  			This function must be called after all the configuration of simulation has finished.
  			Method stepSimulation() can be called after calling this function.
  			@endif
  		*/
       case 7:  // OpenHRP/DynamicsSimulator/initSimulation
       {
         this.initSimulation ();
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief シミュレーション世界での次の状態を計算します。
  		 *
  		 * ループで繰り返し呼ぶことによりシミュレーションが行われます。
  		 *
  		 * メソッド initSimulation() はこのループの前に呼んでください。
  		 * @else
  			calculate the next state of the simulation world.
  			
  			The function repeatedly called in the simulation loop.
  			Method initSimulaiton() must be called before running the simulation loop.
  			* endif
  		*/
       case 8:  // OpenHRP/DynamicsSimulator/stepSimulation
       {
         this.stepSimulation ();
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief データをリンクへセットします。
  		 *
  		 * @param	character	キャラクタ名
  		 * @param	link		リンク名
  		 * @param	type		データ種別
  		 * @param	data		データ
  		 * @else
  		 * Set Data to Link
  		 * @param	character	Character Name
  		 * @param	link		Link Name
  		 * @param	type		Type of data to Set
  		 * @param	data		Data to send
  		 * @endif
  		 */
       case 9:  // OpenHRP/DynamicsSimulator/setCharacterLinkData
       {
         String character = in.read_string ();
         String link = in.read_string ();
         jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataType type = jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataTypeHelper.read (in);
         double data[] = jp.go.aist.hrp.simulator.DblSequenceHelper.read (in);
         this.setCharacterLinkData (character, link, type, data);
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief リンクのデータを取得します。
  		 * @param	characterName	キャラクタ名
  		 * @param	link			リンク名
  		 * @param	type			取得するデータ種別
  		 * @param	rdata			データ
  		 * @else
  		 * Get Data from Link
  		 * @param	characterName	Character Name
  		 * @param	link			Link Name
  		 * @param	type			Type of data to get
  		 * @param	rdata			Data placement area
  		 * @endif
  		 */
       case 10:  // OpenHRP/DynamicsSimulator/getCharacterLinkData
       {
         String characterName = in.read_string ();
         String link = in.read_string ();
         jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataType type = jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataTypeHelper.read (in);
         jp.go.aist.hrp.simulator.DblSequenceHolder rdata = new jp.go.aist.hrp.simulator.DblSequenceHolder ();
         this.getCharacterLinkData (characterName, link, type, rdata);
         out = $rh.createReply();
         jp.go.aist.hrp.simulator.DblSequenceHelper.write (out, rdata.value);
         break;
       }


  /**
  		 * @if jp
  		 * @brief リンクのデータを全て取得します。
  		 *
  		 * Joint のうち、 jointId がついているもののデータを jointId順に取得します。
  		 *
  		 * 角度、速度、加速度、トルクのみが有効です。
  		 * @param	characterName	キャラクタ名
  		 * @param	type		データ種別 (角度、速度、加速度、トルクのみが有効)
  		 * @param	wdata		データ
  		 * 
  		 * @else
  		 * Joint - (Angle, Speed, Acceleration, Torque)
  		 * for all links
  		 * @param	characterName	Character Name
  		 * @param	type		Data to set.Only valid for:
  		 *						angle, velocity, acceleration, torque
  		 * @param	wdata		Parameter Value
  		 * @endif
  		 * todo
  		 */
       case 11:  // OpenHRP/DynamicsSimulator/getCharacterAllLinkData
       {
         String characterName = in.read_string ();
         jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataType type = jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataTypeHelper.read (in);
         jp.go.aist.hrp.simulator.DblSequenceHolder wdata = new jp.go.aist.hrp.simulator.DblSequenceHolder ();
         this.getCharacterAllLinkData (characterName, type, wdata);
         out = $rh.createReply();
         jp.go.aist.hrp.simulator.DblSequenceHelper.write (out, wdata.value);
         break;
       }


  /**
  		 * @if jp
  		 * リンクのデータを全てセットします。
  		 * 
  		 * Joint のうち、 jointId がついているもののデータを jointId順に取得します。
  		 * 
  		 * 角度、速度、加速度、トルクのみが有効です。
  		 *
  		 *
  		 * @param	characterName	キャラクタ名
  		 * @param	type		データ種別 (角度、速度、加速度、トルクのみが有効)
  		 * @param	wdata		データ
  		 * @else
  		 * Joint - (Angle, Speed, Acceleration, Torque)
  		 * for all links
  		 * @param	characterName	Character Name
  		 * @param	type		Data to set.Only valid for:
  		 *						angle, velocity, acceleration, torque
  		 * @param	wdata		Parameter Value
  		 * @endif
  		 */
       case 12:  // OpenHRP/DynamicsSimulator/setCharacterAllLinkData
       {
         String characterName = in.read_string ();
         jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataType type = jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataTypeHelper.read (in);
         double wdata[] = jp.go.aist.hrp.simulator.DblSequenceHelper.read (in);
         this.setCharacterAllLinkData (characterName, type, wdata);
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief 重力ベクトルを設定します。
  		 *
  		 * @param wdata 重力ベクトル
  		 * @else
  		 * Set World G-Vector
  		 * @endif
  		 */
       case 13:  // OpenHRP/DynamicsSimulator/setGVector
       {
         double wdata[] = jp.go.aist.hrp.simulator.DblSequence3Helper.read (in);
         this.setGVector (wdata);
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief 重力ベクトルを取得します。
  		 * @param 重力ベクトル
  		 * @else
  		 * Get World G-Vector
  		 * @endif
  		 */
       case 14:  // OpenHRP/DynamicsSimulator/getGVector
       {
         jp.go.aist.hrp.simulator.DblSequence3Holder wdata = new jp.go.aist.hrp.simulator.DblSequence3Holder ();
         this.getGVector (wdata);
         out = $rh.createReply();
         jp.go.aist.hrp.simulator.DblSequence3Helper.write (out, wdata.value);
         break;
       }


  /**
  		 * @if jp
  		 * @brief キャラクタの全ての Joint のモードをセットします。
  		 * 
  		 * @param キャラクタ名
  		 * @param モード
  		 * @else
  		 * Set Character All Joint Modes
  		 * @param characterName
  		 * @param jointMode
  		 * @endif
  		 */
       case 15:  // OpenHRP/DynamicsSimulator/setCharacterAllJointModes
       {
         String characterName = in.read_string ();
         jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.JointDriveMode jointMode = jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.JointDriveModeHelper.read (in);
         this.setCharacterAllJointModes (characterName, jointMode);
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief 逆運動学を計算します。
  		 * @param characterName 計算する対象のキャラクタ名
  		 * @param baseLink		ベースの動かないリンク
  		 * @param targetLink	ターゲットの動くリンク
  		 * @param target		目標の位置と姿勢
  		 * @else
  		 * Calculate Inverse Kinematics
  		 * @param characterName Name of Character to move
  		 * @param baseLink		Name of the base link(not moved)
  		 * @param targetLink	Name of the target link(moved)
  		 * @param target		Goal position and attitude for target link.
  		 * @endif
  		 */
       case 16:  // OpenHRP/DynamicsSimulator/calcCharacterInverseKinematics
       {
         String characterName = in.read_string ();
         String baseLink = in.read_string ();
         String targetLink = in.read_string ();
         jp.go.aist.hrp.simulator.LinkPosition target = jp.go.aist.hrp.simulator.LinkPositionHelper.read (in);
         boolean $result = false;
         $result = this.calcCharacterInverseKinematics (characterName, baseLink, targetLink, target);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
  		 * @if jp
  		 * @brief キャラクタの順運動学を計算します。
  		 * @param characterName キャラクタ名
  		 * @else
  		 * Calculate forward kinematics for a character in world.
  		 * @param characterName
  		 * @endif
  		 */
       case 17:  // OpenHRP/DynamicsSimulator/calcCharacterForwardKinematics
       {
         String characterName = in.read_string ();
         this.calcCharacterForwardKinematics (characterName);
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief 全てのキャラクタ順運動学を計算します。
  		 * @else
  		 * Calculate all forward kinematics for all characters in world.
  		 * @endif
  		 */
       case 18:  // OpenHRP/DynamicsSimulator/calcWorldForwardKinematics
       {
         this.calcWorldForwardKinematics ();
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief 全てのキャラクタ順運動学を計算し、干渉チェックを行います。
  		 * @else
  		 * Check for collision after calculation of kinematics.
  		 * @endif
  		 */
       case 19:  // OpenHRP/DynamicsSimulator/checkCollision
       {
         this.checkCollision ();
         out = $rh.createReply();
         break;
       }


  /**
  		 * @if jp
  		 * @brief シミュレーションの状態を表すWorldStateを取得します。
  		 * @param state シミュレーションの状態
  		 * @else
  		 * Get state of simulated world
  		 * @param state     State of simulated world
  		 * @endif
  		 */
       case 20:  // OpenHRP/DynamicsSimulator/getWorldState
       {
         jp.go.aist.hrp.simulator.WorldStateHolder wstate = new jp.go.aist.hrp.simulator.WorldStateHolder ();
         this.getWorldState (wstate);
         out = $rh.createReply();
         jp.go.aist.hrp.simulator.WorldStateHelper.write (out, wstate.value);
         break;
       }


  /**
  		 * @if jp
  		 * @brief キャラクタのセンサ状態一覧を取得します。
  		 * @param characterName キャラクタ名
  		 * @param sstate センサ状態一覧
  		 * @endif
  		 */
       case 21:  // OpenHRP/DynamicsSimulator/getCharacterSensorState
       {
         String characterName = in.read_string ();
         jp.go.aist.hrp.simulator.SensorStateHolder sstate = new jp.go.aist.hrp.simulator.SensorStateHolder ();
         this.getCharacterSensorState (characterName, sstate);
         out = $rh.createReply();
         jp.go.aist.hrp.simulator.SensorStateHelper.write (out, sstate.value);
         break;
       }


  /**
  		 * @if jp
  		 * @brief 衝突しているリンクのペアを取得します。
  		 * @param characterName 取得するキャラクタ名
  		 * @param pairs 衝突しているペアについての情報
  		 * @else
  		 * Get information on colliding pairs
  		 * @param characterName Name of Character to check
  		 * @param pairs			Information on colliding pairs.
  		 * @endif
  		 */
       case 22:  // OpenHRP/DynamicsSimulator/getCharacterCollidingPairs
       {
         String characterName = in.read_string ();
         jp.go.aist.hrp.simulator.LinkPairSequenceHolder pairs = new jp.go.aist.hrp.simulator.LinkPairSequenceHolder ();
         boolean $result = false;
         $result = this.getCharacterCollidingPairs (characterName, pairs);
         out = $rh.createReply();
         out.write_boolean ($result);
         jp.go.aist.hrp.simulator.LinkPairSequenceHelper.write (out, pairs.value);
         break;
       }


  /**
  		 * @if jp
  		 * @brief キャラクタの指定したリンクパスに対するヤコビアンを取得します。
  		 * @param characterName	ヤコビアンを計算するキャラクタ名
  		 * @param baseLink		ベースのリンク名
  		 * @param targetLink	ターゲットのリンク名
  		 * @param jacobian		結果のヤコビアン
  		 * @else
  		 * compute the Jacobian matrix and its time derivative
  		 * @param characterName	Name of Character to calculate Jacobian.
  		 * @param baseLink		Name of base link.
  		 * @param targetLink	Name of target link.
  		 * @param jacobian		Jacobian Matrix returned from function here.
  		 * @endif
  		 */
       case 23:  // OpenHRP/DynamicsSimulator/calcCharacterJacobian
       {
         String characterName = in.read_string ();
         String baseLink = in.read_string ();
         String targetLink = in.read_string ();
         jp.go.aist.hrp.simulator.DblSequenceHolder jacobian = new jp.go.aist.hrp.simulator.DblSequenceHolder ();
         this.calcCharacterJacobian (characterName, baseLink, targetLink, jacobian);
         out = $rh.createReply();
         jp.go.aist.hrp.simulator.DblSequenceHelper.write (out, jacobian.value);
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:OpenHRP/DynamicsSimulator:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public DynamicsSimulator _this() 
  {
    return DynamicsSimulatorHelper.narrow(
    super._this_object());
  }

  public DynamicsSimulator _this(org.omg.CORBA.ORB orb) 
  {
    return DynamicsSimulatorHelper.narrow(
    super._this_object(orb));
  }


} // class DynamicsSimulatorPOA
