package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/OnlineViewerOperations.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/OnlineViewer.idl
* 2009年2月18日 12時58分37秒 JST
*/


/**
   * @if jp
   * OnlineViewer インターフェース
   *
   * GrxUI の 3DView をクライアントプログラムから表示させる際に使用します。
   *
   * load() で読み込んだモデルに対して update() で情報を与えることでアニメーションします。
   *
   * また、 update() を使用すると情報は記録され、後で再生することもできます。
   */
public interface OnlineViewerOperations 
{

  /**
       * @if jp
       * 表示内容を更新します
       *
       * 内容は記録され、後で再生し直すことができます。
       * @param state 更新する表示内容の情報
       * @else
       * Update Display
       * @endif
       */
  void update (jp.go.aist.hrp.simulator.WorldState state);

  /**
       * @if jp
       * モデルの読み込みを行います。
       * @param name モデル名
       * @param url モデルファイルURL
       * @endif 
       */
  void load (String name, String url);

  /**
       * @if jp
       * 記録されたいままでの更新をクリアします。
       * @endif
       */
  void clearLog ();

  /**
       * @if jp
       * データをクリアします。
       * @endif
       */
  void clearData ();

  /**
       * @if jp
       * 表示内容を更新します。 update() とは違い、更新内容を記録しません。
       * @param state 更新する表示内容の情報
       * @else
       * state display without recording  '03 Apr.4  s.kajita
       * @endif
       */
  void drawScene (jp.go.aist.hrp.simulator.WorldState state);

  /**
       * @if jp
       * 線の幅を設定します。
       * @endif
       */
  void setLineWidth (float width);

  /**
       * @if jp
       * スケールを設定します。
       * @endif
       */
  void setLineScale (float scale);

  /**
       * @if jp
       * 
       * @endif
       */
  boolean getPosture (String robotId, jp.go.aist.hrp.simulator.DblSequenceHolder posture);
} // interface OnlineViewerOperations
