package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/_DynamicsSimulatorStub.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/DynamicsSimulator.idl
* 2009年2月18日 12時58分36秒 JST
*/


/**
	 * @if jp
	 * @brief DynamicsSimulator インターフェース
	 *
	 * 力学シミュレーションを行うサーバです。使用する際は以下の流れで行います。
	 *
	 * -# DynamicsSimulatorFactory の参照を取得
	 * -# DynamicsSimulatorFactory::create() で DynamicsSimulator を取得
	 * -# registerCharacter() でキャラクタを登録
	 * -# init() でシミュレーションの設定
	 * -# setGVector() で重力ベクトルの設定
	 * -# setCharacterAllJointModes() で関節駆動モードの設定
	 * -# setCharacterAllLinkData() で初期姿勢を与え、 calcWorldForwardKinematics() を実行し順運動学を１回実行
	 * -# registerCollisionCheckPair() をどの関節/キャラクタに対して干渉チェックを実行するかを設定する
	 * -# initSimulation() でサーバの初期化
	 *
	 * 以下、シミュレーションループ
	 *
	 * -# stepSimulation() でシミュレーションを1ステップ実行
	 * -# getWorldState() で現在の状況を取得
	 * @else
	 * Dynamics Server
	 *
	 * @date	2006.02.02
	 * @version	pre2.0 
	 * modified	2006.02.24 some functions needed to specify character name
	 * @endif
	 */
public class _DynamicsSimulatorStub extends org.omg.CORBA.portable.ObjectImpl implements jp.go.aist.hrp.simulator.DynamicsSimulator
{


  /**
  		 * @if jp
  		 * サーバを終了します。
  		 * @else
  		 * Object Destruction
  		 * @endif
  		 */
  public void destroy ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("destroy", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                destroy (        );
            } finally {
                _releaseReply ($in);
            }
  } // destroy


  /**
  		 * @if jp
  		 * @brief キャラクタを登録する。
  		 * 
  		 * ModelLoader から得られた情報でキャラクタを登録します。
  		 * @param name シミュレーションでのキャラクタ名
  		 * @param cinfo ModelLoader から得られる CharacterInfo
  		 * @else
  		 * Register a character
  		 * @param	name	Object Character Name for Simulation
  		 * @param	cinfo	CharacterInfo
  		 * @endif
  		 */
  public void registerCharacter (String name, jp.go.aist.hrp.simulator.CharacterInfo cinfo)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("registerCharacter", true);
                $out.write_string (name);
                jp.go.aist.hrp.simulator.CharacterInfoHelper.write ($out, cinfo);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                registerCharacter (name, cinfo        );
            } finally {
                _releaseReply ($in);
            }
  } // registerCharacter


  /**
  		 * @if jp
  		 * @brief サーバを初期化します。
  		 *
  		 * シミュレーションの条件を設定し、サーバを初期化します。
  		 * @param timeStep シミュレーション1ステップごとの時間[s]
  		 * @param integrateopt 積分に用いる手法(オイラー法, ルンゲクッタ法)
  		 * @param sensorOpt センサーを使用するか
  		 * @else
  		 * Initialise Server
  		 * @param timeStep		The timestep to be used for integration.
  		 * @param integrateOpt  The integration method to use.
  		 * @param sensorOpt	    The sensor option to be used.
  		 * @endif
  		 */
  public void init (double timeStep, jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.IntegrateMethod integrateOpt, jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.SensorOption sensorOpt)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("init", true);
                $out.write_double (timeStep);
                jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.IntegrateMethodHelper.write ($out, integrateOpt);
                jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.SensorOptionHelper.write ($out, sensorOpt);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                init (timeStep, integrateOpt, sensorOpt        );
            } finally {
                _releaseReply ($in);
            }
  } // init


  /**
  		 * @if jp
  		 * @brief 衝突検出ペアを追加します。
  		 *
  		 * ここで登録されたペア同士の衝突検出が行われます。
  		 *
  		 * K と C の長さを0にするとスプリング-ダンパ法は使用されません。
  		 * @param	char1	  リンクのキャラクタ名
  		 * @param	name1	  リンク名
  		 * @param	char2     もう一方のキャラクタ名
  		 * @param	name2     リンク名
  		 * @param	staticFriction  静止摩擦係数
  		 * @param   slipFriction  動摩擦係数
  		 * @param	K ばね係数
  		 * @param	C ダンパ係数
  		 * @else
  		 * Add Collision Pairs
  		 * @param	char1	  Name of character for first link
  		 * @param	name1	  Name of first link
  		 * @param	char2     Name of character for second link
  		 * @param	name2     Name of second link
  		 * @param	staticFriction  Static Friction
  		 * @param   slipFriction  Slip Friction
  		 * @param	K Parameters for Spring
  		 * @param	C Parameters for Damper
  		 * K and C should be of zero length for no Spring-Damper stuff.
  		 * @endif
  		 */
  public void registerCollisionCheckPair (String char1, String name1, String char2, String name2, double staticFriction, double slipFriction, double[] K, double[] C)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("registerCollisionCheckPair", true);
                $out.write_string (char1);
                $out.write_string (name1);
                $out.write_string (char2);
                $out.write_string (name2);
                $out.write_double (staticFriction);
                $out.write_double (slipFriction);
                jp.go.aist.hrp.simulator.DblSequence6Helper.write ($out, K);
                jp.go.aist.hrp.simulator.DblSequence6Helper.write ($out, C);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                registerCollisionCheckPair (char1, name1, char2, name2, staticFriction, slipFriction, K, C        );
            } finally {
                _releaseReply ($in);
            }
  } // registerCollisionCheckPair


  /**
  		 * @if jp
  		 * @brief 仮想リンクを追加します。
  		 *
  		 * @note 実装されていません。
  		 * @param	char1			 キャラクタ名
  		 * @param	link1			 リンク名
  		 * @param	char2			 もう一方のキャラクタ名
  		 * @param	link2			 リンク名
  		 * @param	relTransform	 ふたつのリンク関係の回転/位置のクォータニアン
  		 * @param   transformDefined どちらの変換が使用されるか
  		 * @param	constraint		 拘束する自由度
  		 * @param	connectionName	 仮想リンクの名前
  		 *
  		 * @else
  		 * register Virtual Link
  		 * @param	char1			 Name of character for first link
  		 * @param	link1			 Name of first link
  		 * @param	char2			 Name of character for second link
  		 * @param	link2			 Name of second link
  		 * @param	relTransform	 relative pos+att as quaternion transform
  		 * @param   transformDefined Flag for whether tranform is defined.
  		 * @param	constraint		 Constraints to be included in Link.
  		 * @param	connectionName	 Name for the virtual link.
  		 * Unimplemented
  		 * @endif
  		 */
  public void registerVirtualLink (String char1, String link1, String char2, String link2, jp.go.aist.hrp.simulator.LinkPosition relTransform, short transformDefined, double[] constraint, String connectionName)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("registerVirtualLink", true);
                $out.write_string (char1);
                $out.write_string (link1);
                $out.write_string (char2);
                $out.write_string (link2);
                jp.go.aist.hrp.simulator.LinkPositionHelper.write ($out, relTransform);
                $out.write_short (transformDefined);
                jp.go.aist.hrp.simulator.DblSequence9Helper.write ($out, constraint);
                $out.write_string (connectionName);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                registerVirtualLink (char1, link1, char2, link2, relTransform, transformDefined, constraint, connectionName        );
            } finally {
                _releaseReply ($in);
            }
  } // registerVirtualLink


  /**
  		 * @if jp
  		 * @brief registerVirtualLink() で登録した拘束にかかる力を取得します。
  		 *
  		 * @note 実装されていません
  		 * @param	characterName   キャラクタ名
  		 * @param	connectionName  コネクション名
  		 * @param	contactForce    拘束にかかる力
  		 *
  		 * @else
  		 * Get Connection Constraint Force
  		 *
  		 * @param	characterName   Character Name
  		 * @param	connectionName  Connection Name
  		 * @param	contactForce    Connection Contraint Force
  		 * unimplemented
  		 * @endif
  		 */
  public void getConnectionConstraintForce (String characterName, String connectionName, jp.go.aist.hrp.simulator.DblSequence6Holder contactForce)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getConnectionConstraintForce", true);
                $out.write_string (characterName);
                $out.write_string (connectionName);
                $in = _invoke ($out);
                contactForce.value = jp.go.aist.hrp.simulator.DblSequence6Helper.read ($in);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                getConnectionConstraintForce (characterName, connectionName, contactForce        );
            } finally {
                _releaseReply ($in);
            }
  } // getConnectionConstraintForce


  /**
  		 * @if jp
  		 * @brief センサ値を取得します。
  		 *
  		 * @param   characterName	センサーがついているキャラクタ名
  		 * @param	sensorName		センサ名
  		 * @param	sensorOutput	センサ出力
  		 *
  		 * @else
  		 * Get Sensor Values
  		 * @param   characterName	Name of character with sensor.
  		 * @param	sensorName		Name of sensor.
  		 * @param	sensorOutput	Place to put data from sensor.
  		 * @endif
  		 */
  public void getCharacterSensorValues (String characterName, String sensorName, jp.go.aist.hrp.simulator.DblSequenceHolder values)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getCharacterSensorValues", true);
                $out.write_string (characterName);
                $out.write_string (sensorName);
                $in = _invoke ($out);
                values.value = jp.go.aist.hrp.simulator.DblSequenceHelper.read ($in);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                getCharacterSensorValues (characterName, sensorName, values        );
            } finally {
                _releaseReply ($in);
            }
  } // getCharacterSensorValues


  /**
  		 * @if jp
  		 * @brief シミュレーション前の初期化をおこないます。
  		 *
  		 * このメソッドは全ての設定が終了した後に呼ばれなければなりません。
  		 * メソッド stepSimulation() はこのメソッド終了後に呼ぶことができます。
  		 * @else
  			Initialize the simulation state so that the simulator can begin a simulation.
  
  			This function must be called after all the configuration of simulation has finished.
  			Method stepSimulation() can be called after calling this function.
  			@endif
  		*/
  public void initSimulation ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("initSimulation", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                initSimulation (        );
            } finally {
                _releaseReply ($in);
            }
  } // initSimulation


  /**
  		 * @if jp
  		 * @brief シミュレーション世界での次の状態を計算します。
  		 *
  		 * ループで繰り返し呼ぶことによりシミュレーションが行われます。
  		 *
  		 * メソッド initSimulation() はこのループの前に呼んでください。
  		 * @else
  			calculate the next state of the simulation world.
  			
  			The function repeatedly called in the simulation loop.
  			Method initSimulaiton() must be called before running the simulation loop.
  			* endif
  		*/
  public void stepSimulation ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("stepSimulation", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                stepSimulation (        );
            } finally {
                _releaseReply ($in);
            }
  } // stepSimulation


  /**
  		 * @if jp
  		 * @brief データをリンクへセットします。
  		 *
  		 * @param	character	キャラクタ名
  		 * @param	link		リンク名
  		 * @param	type		データ種別
  		 * @param	data		データ
  		 * @else
  		 * Set Data to Link
  		 * @param	character	Character Name
  		 * @param	link		Link Name
  		 * @param	type		Type of data to Set
  		 * @param	data		Data to send
  		 * @endif
  		 */
  public void setCharacterLinkData (String character, String link, jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataType type, double[] data)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setCharacterLinkData", true);
                $out.write_string (character);
                $out.write_string (link);
                jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataTypeHelper.write ($out, type);
                jp.go.aist.hrp.simulator.DblSequenceHelper.write ($out, data);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setCharacterLinkData (character, link, type, data        );
            } finally {
                _releaseReply ($in);
            }
  } // setCharacterLinkData


  /**
  		 * @if jp
  		 * @brief リンクのデータを取得します。
  		 * @param	characterName	キャラクタ名
  		 * @param	link			リンク名
  		 * @param	type			取得するデータ種別
  		 * @param	rdata			データ
  		 * @else
  		 * Get Data from Link
  		 * @param	characterName	Character Name
  		 * @param	link			Link Name
  		 * @param	type			Type of data to get
  		 * @param	rdata			Data placement area
  		 * @endif
  		 */
  public void getCharacterLinkData (String characterName, String link, jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataType type, jp.go.aist.hrp.simulator.DblSequenceHolder rdata)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getCharacterLinkData", true);
                $out.write_string (characterName);
                $out.write_string (link);
                jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataTypeHelper.write ($out, type);
                $in = _invoke ($out);
                rdata.value = jp.go.aist.hrp.simulator.DblSequenceHelper.read ($in);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                getCharacterLinkData (characterName, link, type, rdata        );
            } finally {
                _releaseReply ($in);
            }
  } // getCharacterLinkData


  /**
  		 * @if jp
  		 * @brief リンクのデータを全て取得します。
  		 *
  		 * Joint のうち、 jointId がついているもののデータを jointId順に取得します。
  		 *
  		 * 角度、速度、加速度、トルクのみが有効です。
  		 * @param	characterName	キャラクタ名
  		 * @param	type		データ種別 (角度、速度、加速度、トルクのみが有効)
  		 * @param	wdata		データ
  		 * 
  		 * @else
  		 * Joint - (Angle, Speed, Acceleration, Torque)
  		 * for all links
  		 * @param	characterName	Character Name
  		 * @param	type		Data to set.Only valid for:
  		 *						angle, velocity, acceleration, torque
  		 * @param	wdata		Parameter Value
  		 * @endif
  		 * todo
  		 */
  public void getCharacterAllLinkData (String characterName, jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataType type, jp.go.aist.hrp.simulator.DblSequenceHolder wdata)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getCharacterAllLinkData", true);
                $out.write_string (characterName);
                jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataTypeHelper.write ($out, type);
                $in = _invoke ($out);
                wdata.value = jp.go.aist.hrp.simulator.DblSequenceHelper.read ($in);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                getCharacterAllLinkData (characterName, type, wdata        );
            } finally {
                _releaseReply ($in);
            }
  } // getCharacterAllLinkData


  /**
  		 * @if jp
  		 * リンクのデータを全てセットします。
  		 * 
  		 * Joint のうち、 jointId がついているもののデータを jointId順に取得します。
  		 * 
  		 * 角度、速度、加速度、トルクのみが有効です。
  		 *
  		 *
  		 * @param	characterName	キャラクタ名
  		 * @param	type		データ種別 (角度、速度、加速度、トルクのみが有効)
  		 * @param	wdata		データ
  		 * @else
  		 * Joint - (Angle, Speed, Acceleration, Torque)
  		 * for all links
  		 * @param	characterName	Character Name
  		 * @param	type		Data to set.Only valid for:
  		 *						angle, velocity, acceleration, torque
  		 * @param	wdata		Parameter Value
  		 * @endif
  		 */
  public void setCharacterAllLinkData (String characterName, jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataType type, double[] wdata)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setCharacterAllLinkData", true);
                $out.write_string (characterName);
                jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.LinkDataTypeHelper.write ($out, type);
                jp.go.aist.hrp.simulator.DblSequenceHelper.write ($out, wdata);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setCharacterAllLinkData (characterName, type, wdata        );
            } finally {
                _releaseReply ($in);
            }
  } // setCharacterAllLinkData


  /**
  		 * @if jp
  		 * @brief 重力ベクトルを設定します。
  		 *
  		 * @param wdata 重力ベクトル
  		 * @else
  		 * Set World G-Vector
  		 * @endif
  		 */
  public void setGVector (double[] wdata)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setGVector", true);
                jp.go.aist.hrp.simulator.DblSequence3Helper.write ($out, wdata);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setGVector (wdata        );
            } finally {
                _releaseReply ($in);
            }
  } // setGVector


  /**
  		 * @if jp
  		 * @brief 重力ベクトルを取得します。
  		 * @param 重力ベクトル
  		 * @else
  		 * Get World G-Vector
  		 * @endif
  		 */
  public void getGVector (jp.go.aist.hrp.simulator.DblSequence3Holder wdata)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getGVector", true);
                $in = _invoke ($out);
                wdata.value = jp.go.aist.hrp.simulator.DblSequence3Helper.read ($in);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                getGVector (wdata        );
            } finally {
                _releaseReply ($in);
            }
  } // getGVector


  /**
  		 * @if jp
  		 * @brief キャラクタの全ての Joint のモードをセットします。
  		 * 
  		 * @param キャラクタ名
  		 * @param モード
  		 * @else
  		 * Set Character All Joint Modes
  		 * @param characterName
  		 * @param jointMode
  		 * @endif
  		 */
  public void setCharacterAllJointModes (String characterName, jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.JointDriveMode jointMode)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setCharacterAllJointModes", true);
                $out.write_string (characterName);
                jp.go.aist.hrp.simulator.DynamicsSimulatorPackage.JointDriveModeHelper.write ($out, jointMode);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setCharacterAllJointModes (characterName, jointMode        );
            } finally {
                _releaseReply ($in);
            }
  } // setCharacterAllJointModes


  /**
  		 * @if jp
  		 * @brief 逆運動学を計算します。
  		 * @param characterName 計算する対象のキャラクタ名
  		 * @param baseLink		ベースの動かないリンク
  		 * @param targetLink	ターゲットの動くリンク
  		 * @param target		目標の位置と姿勢
  		 * @else
  		 * Calculate Inverse Kinematics
  		 * @param characterName Name of Character to move
  		 * @param baseLink		Name of the base link(not moved)
  		 * @param targetLink	Name of the target link(moved)
  		 * @param target		Goal position and attitude for target link.
  		 * @endif
  		 */
  public boolean calcCharacterInverseKinematics (String characterName, String baseLink, String targetLink, jp.go.aist.hrp.simulator.LinkPosition target)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("calcCharacterInverseKinematics", true);
                $out.write_string (characterName);
                $out.write_string (baseLink);
                $out.write_string (targetLink);
                jp.go.aist.hrp.simulator.LinkPositionHelper.write ($out, target);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return calcCharacterInverseKinematics (characterName, baseLink, targetLink, target        );
            } finally {
                _releaseReply ($in);
            }
  } // calcCharacterInverseKinematics


  /**
  		 * @if jp
  		 * @brief キャラクタの順運動学を計算します。
  		 * @param characterName キャラクタ名
  		 * @else
  		 * Calculate forward kinematics for a character in world.
  		 * @param characterName
  		 * @endif
  		 */
  public void calcCharacterForwardKinematics (String characterName)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("calcCharacterForwardKinematics", true);
                $out.write_string (characterName);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                calcCharacterForwardKinematics (characterName        );
            } finally {
                _releaseReply ($in);
            }
  } // calcCharacterForwardKinematics


  /**
  		 * @if jp
  		 * @brief 全てのキャラクタ順運動学を計算します。
  		 * @else
  		 * Calculate all forward kinematics for all characters in world.
  		 * @endif
  		 */
  public void calcWorldForwardKinematics ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("calcWorldForwardKinematics", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                calcWorldForwardKinematics (        );
            } finally {
                _releaseReply ($in);
            }
  } // calcWorldForwardKinematics


  /**
  		 * @if jp
  		 * @brief 全てのキャラクタ順運動学を計算し、干渉チェックを行います。
  		 * @else
  		 * Check for collision after calculation of kinematics.
  		 * @endif
  		 */
  public void checkCollision ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("checkCollision", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                checkCollision (        );
            } finally {
                _releaseReply ($in);
            }
  } // checkCollision


  /**
  		 * @if jp
  		 * @brief シミュレーションの状態を表すWorldStateを取得します。
  		 * @param state シミュレーションの状態
  		 * @else
  		 * Get state of simulated world
  		 * @param state     State of simulated world
  		 * @endif
  		 */
  public void getWorldState (jp.go.aist.hrp.simulator.WorldStateHolder wstate)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getWorldState", true);
                $in = _invoke ($out);
                wstate.value = jp.go.aist.hrp.simulator.WorldStateHelper.read ($in);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                getWorldState (wstate        );
            } finally {
                _releaseReply ($in);
            }
  } // getWorldState


  /**
  		 * @if jp
  		 * @brief キャラクタのセンサ状態一覧を取得します。
  		 * @param characterName キャラクタ名
  		 * @param sstate センサ状態一覧
  		 * @endif
  		 */
  public void getCharacterSensorState (String characterName, jp.go.aist.hrp.simulator.SensorStateHolder sstate)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getCharacterSensorState", true);
                $out.write_string (characterName);
                $in = _invoke ($out);
                sstate.value = jp.go.aist.hrp.simulator.SensorStateHelper.read ($in);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                getCharacterSensorState (characterName, sstate        );
            } finally {
                _releaseReply ($in);
            }
  } // getCharacterSensorState


  /**
  		 * @if jp
  		 * @brief 衝突しているリンクのペアを取得します。
  		 * @param characterName 取得するキャラクタ名
  		 * @param pairs 衝突しているペアについての情報
  		 * @else
  		 * Get information on colliding pairs
  		 * @param characterName Name of Character to check
  		 * @param pairs			Information on colliding pairs.
  		 * @endif
  		 */
  public boolean getCharacterCollidingPairs (String characterName, jp.go.aist.hrp.simulator.LinkPairSequenceHolder pairs)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getCharacterCollidingPairs", true);
                $out.write_string (characterName);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                pairs.value = jp.go.aist.hrp.simulator.LinkPairSequenceHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getCharacterCollidingPairs (characterName, pairs        );
            } finally {
                _releaseReply ($in);
            }
  } // getCharacterCollidingPairs


  /**
  		 * @if jp
  		 * @brief キャラクタの指定したリンクパスに対するヤコビアンを取得します。
  		 * @param characterName	ヤコビアンを計算するキャラクタ名
  		 * @param baseLink		ベースのリンク名
  		 * @param targetLink	ターゲットのリンク名
  		 * @param jacobian		結果のヤコビアン
  		 * @else
  		 * compute the Jacobian matrix and its time derivative
  		 * @param characterName	Name of Character to calculate Jacobian.
  		 * @param baseLink		Name of base link.
  		 * @param targetLink	Name of target link.
  		 * @param jacobian		Jacobian Matrix returned from function here.
  		 * @endif
  		 */
  public void calcCharacterJacobian (String characterName, String baseLink, String targetLink, jp.go.aist.hrp.simulator.DblSequenceHolder jacobian)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("calcCharacterJacobian", true);
                $out.write_string (characterName);
                $out.write_string (baseLink);
                $out.write_string (targetLink);
                $in = _invoke ($out);
                jacobian.value = jp.go.aist.hrp.simulator.DblSequenceHelper.read ($in);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                calcCharacterJacobian (characterName, baseLink, targetLink, jacobian        );
            } finally {
                _releaseReply ($in);
            }
  } // calcCharacterJacobian

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:OpenHRP/DynamicsSimulator:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _DynamicsSimulatorStub
